// cvisionDlg.cpp : file di implementazione
//
#include <vector>
#include "stdafx.h"
#include "cvision.h"
#include "cvapp.h"
#include "cvisionDlg.h"
#include ".\cvisiondlg.h"
//#include ".\cvisiondlg.h"  modif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// finestra di dialogo CcvisionDlg



CcvisionDlg::CcvisionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CcvisionDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CcvisionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_list);
}


BEGIN_MESSAGE_MAP(CcvisionDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnOpen)
	ON_BN_CLICKED(IDC_BUTTON2, OnErosion)
	ON_BN_CLICKED(IDC_BUTTON3, ScannaESbianca)
	ON_BN_CLICKED(IDC_BUTTON4, Bordi)
	ON_LBN_SELCHANGE(IDC_LIST1, OnLbnSelchangeList1)
END_MESSAGE_MAP()


// gestori di messaggi di CcvisionDlg

BOOL CcvisionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Impostare l'icona per questa finestra di dialogo. Il framework non esegue questa operazione automaticamente
	//  se la finestra principale dell'applicazione non  una finestra di dialogo.
	SetIcon(m_hIcon, TRUE);			// Impostare icona grande.
	SetIcon(m_hIcon, FALSE);		// Impostare icona piccola.

	// TODO: aggiungere qui inizializzazione aggiuntiva.
	
	return TRUE;  // restituisce TRUE a meno che non venga impostato lo stato attivo su un controllo.
}

// Se si aggiunge alla finestra di dialogo un pulsante di riduzione a icona, per trascinare l'icona sar necessario
//  il codice sottostante. Per le applicazioni MFC che utilizzano il modello documento/vista,
//  questa operazione viene eseguita automaticamente dal framework.

void CcvisionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // contesto di periferica per il disegno

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Centrare l'icona nel rettangolo client.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Disegnare l'icona
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Il sistema chiama questa funzione per ottenere la visualizzazione del cursore durante il trascinamento
//  della finestra ridotta a icona.
HCURSOR CcvisionDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

/*void CcvisionDlg::OnOpen() 
{
  CFileDialog dlg(TRUE, _T("*.bmp"), "",OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,"File di immagini (*.bmp; *.jpg) |*.bmp;*.jpg|File AVI(*.avi) |*.avi|Tutti i file(*.*)|*.*||",NULL);
  char title[]= {"Apri Immagine"};
  dlg.m_ofn.lpstrTitle= title;
 
  if (dlg.DoModal() == IDOK) {
 
    CString path= dlg.GetPathName();  // contiene il file selezionato
    if (proc != 0) delete proc;
    proc= new ImageProcessor(path);

  }
}*/


void CcvisionDlg::OnOpen() 
{
  CFileDialog dlg(TRUE, _T("*.bmp"), "", 
                  OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,
                  "image files (*.bmp; *.jpg) |*.bmp;*.jpg|AVI files (*.avi) |*.avi|All Files (*.*)|*.*||",NULL);

  char title[]= {"Open Image"};
  dlg.m_ofn.lpstrTitle= title;

  if (dlg.DoModal() == IDOK) {

    CString path= dlg.GetPathName();
    CString ext= dlg.GetFileExt();

    if (proc != 0)
      delete proc;

    if (procseq != 0)
      delete procseq;

    if (ext.Compare("avi")) {

      proc= new ImageProcessor(path);

    } else {

      procseq= new SequenceProcessor(path);
      std::vector<CString> names= procseq->enumFilters();

      m_list.ResetContent();
      for (int i=0; i<names.size(); i++)
        m_list.AddString(names[i]);
    }
  }
}

void CcvisionDlg::OnErosion()
{		  
	      if (proc != 0) {
			
         // process and display
            proc->reset();
			proc->execute();
            proc->display();
      }

}
void CcvisionDlg::ScannaESbianca()
{
	      if (proc != 0) {
 
         // process and display
            proc->reset();
			proc->execute2();
            proc->display();
      }
}
void CcvisionDlg::Bordi()
{
     if (proc != 0) {
 
         // process and display
            proc->reset();
			proc->execute3();
            proc->display();
      }
}

void CcvisionDlg::OnLbnSelchangeList1()
{
	// TODO: Add your control notification handler code here
}
